# Hamsket <!-- omit in toc -->

<p align="center">
<a href="https://github.com/TheGoddessInari/hamsket"><img src="./resources/Icon.png" width="256px" alt="Hamsket"></a>
</p>

#### Free, Open Source and Cross Platform messaging and emailing app that combines common web applications into one. <!-- omit in toc -->

[![GNU GPL v3][license]](https://www.gnu.org/licenses/gpl-3.0.en.html)
[![Gitter][gitter]](https://gitter.im/TheGoddessInari/hamsket)
[![Release][release]](https://github.com/TheGoddessInari/hamsket/releases/latest)

[![DevOps Build][devops-build]](https://dev.azure.com/TheGoddessInari/hamsket/_build?definitionId=2)
[![DevOps Deployment][devops-deploy]](https://dev.azure.com/TheGoddessInari/hamsket/_release?definitionId=1)
[![Dependencies][dependencies]](https://david-dm.org/TheGoddessInari/hamsket)
[![DevDependencies][dev-dependencies]](https://david-dm.org/TheGoddessInari/hamsket?type=dev)

[license]: https://img.shields.io/github/license/TheGoddessInari/hamsket.svg
[gitter]: https://img.shields.io/gitter/room/TheGoddessInari/hamsket.svg
[release]: https://img.shields.io/github/release/TheGoddessInari/hamsket.svg

[devops-build]: https://img.shields.io/azure-devops/build/TheGoddessInari/f5a88978-10c7-4069-97e0-59b9fc6d36a0/2.svg?logo=azure-devops
[devops-deploy]: https://img.shields.io/azure-devops/release/TheGoddessInari/f5a88978-10c7-4069-97e0-59b9fc6d36a0/1/1.svg?logo=azure-devops
[dependencies]: https://img.shields.io/david/TheGoddessInari/hamsket.svg
[dev-dependencies]: https://img.shields.io/david/dev/TheGoddessInari/hamsket.svg

##### Nightly build artifacts are available in Windows ([Win64](https://github.com/TheGoddessInari/hamsket/releases/download/nightly/Hamsket.Setup.0.6.0.exe)), Mac ([DMG](https://github.com/TheGoddessInari/hamsket/releases/download/nightly/Hamsket-0.6.0.dmg) / [App](https://github.com/TheGoddessInari/hamsket/releases/download/nightly/Hamsket-0.6.0-mac.zip)), and Linux ([AppImage64](https://github.com/TheGoddessInari/hamsket/releases/download/nightly/Hamsket-0.6.0.AppImage) / [RPM64](https://github.com/TheGoddessInari/hamsket/releases/download/nightly/Hamsket-0.6.0.x86_64.rpm) / [DEB64](https://github.com/TheGoddessInari/hamsket/releases/download/nightly/Hamsket_0.6.0_amd64.deb) / [Tarball64](https://github.com/TheGoddessInari/hamsket/releases/download/nightly/Hamsket-0.6.0.tar.gz)) packaging flavors. <!-- omit in toc -->

###### Logo designed by [Andriy Yurchenko](http://andyur.com/). <!-- omit in toc -->

###### Original Rambox by [Ramiro Saenz](https://github.com/saenzramiro). <!-- omit in toc -->

----------

## Table of Contents

- [Table of Contents](#table-of-contents)
- [Screenshot](#screenshot)
- [Services available - 94](#services-available---94)
- [Features](#features)
- [Privacy](#privacy)
- [Donations](#donations)
- [Compiling](#compiling)
- [Contributing](#contributing)
- [Quickstart](#quickstart)
- [Disclosure](#disclosure)
- [License](#license)

----------

## Screenshot

![Hamsket](./resources/screenshots/win1.png)

----------

## Services available - 94

<img width="80" align="left" src="./resources/icons/whatsapp.png" alt="WhatsApp" title="WhatsApp">
<img width="80" align="left" src="./resources/icons/messenger.png" alt="Messenger" title="Messenger">
<img width="80" align="left" src="./resources/icons/skype.png" alt="Skype" title="Skype">
<img width="80" align="left" src="./resources/icons/slack.png" alt="Slack" title="Slack">
<img width="80" align="left" src="./resources/icons/hangouts.png" alt="Hangouts" title="Hangouts">
<img width="80" align="left" src="./resources/icons/telegram.png" alt="Telegram" title="Telegram">
<img width="80" align="left" src="./resources/icons/wechat.png" alt="WeChat" title="WeChat">
<img width="80" align="left" src="./resources/icons/gmail.png" alt="Gmail" title="Gmail">
<img width="80" align="left" src="./resources/icons/hipchat.png" alt="HipChat" title="HipChat">

<img width="80" align="left" src="./resources/icons/chatwork.png" alt="ChatWork" title="ChatWork">
<img width="80" align="left" src="./resources/icons/groupme.png" alt="GroupMe" title="GroupMe">
<img width="80" align="left" src="./resources/icons/grape.png" alt="Grape" title="Grape">
<img width="80" align="left" src="./resources/icons/gitter.png" alt="Gitter" title="Gitter">
<img width="80" align="left" src="./resources/icons/steam.png" alt="Steam" title="Steam">
<img width="80" align="left" src="./resources/icons/discord.png" alt="Discord" title="Discord">
<img width="80" align="left" src="./resources/icons/noysi.png" alt="Noysi" title="Noysi">
<img width="80" align="left" src="./resources/icons/outlook.png" alt="Outlook" title="Outlook">
<img width="80" align="left" src="./resources/icons/outlook365.png" alt="Outlook 365" title="Outlook 365">
<img width="80" align="left" src="./resources/icons/tutanota.png" alt="TutaNota" title="TutaNota">

<img width="80" align="left" src="./resources/icons/hushmail.png" alt="Hushmail" title="Hushmail">
<img width="80" align="left" src="./resources/icons/bearychat.png" alt="BearyChat" title="BearyChat">
<img width="80" align="left" src="./resources/icons/aol.png" alt="Aol" title="Aol">
<img width="80" align="left" src="./resources/icons/sync.png" alt="Sync" title="Sync">
<img width="80" align="left" src="./resources/icons/wire.png" alt="Wire" title="Wire">
<img width="80" align="left" src="./resources/icons/rocketchat.png" alt="Rocket Chat" title="Rocket Chat">
<img width="80" align="left" src="./resources/icons/missive.png" alt="Missive" title="Missive">
<img width="80" align="left" src="./resources/icons/yahoo.png" alt="Yahoo! Mail" title="Yahoo! Mail">
<img width="80" align="left" src="./resources/icons/ryver.png" alt="Ryver" title="Ryver">

<img width="80" align="left" src="./resources/icons/yandex.png" alt="Yandex Mail" title="Yandex Mail">
<img width="80" align="left" src="./resources/icons/dasher.png" alt="Dasher" title="Dasher">
<img width="80" align="left" src="./resources/icons/dingtalk.png" alt="DingTalk" title="DingTalk">
<img width="80" align="left" src="./resources/icons/flowdock.png" alt="FlowDock" title="FlowDock">
<img width="80" align="left" src="./resources/icons/mattermost.png" alt="Mattermost" title="Mattermost">
<img width="80" align="left" src="./resources/icons/voxer.png" alt="Voxer" title="Voxer">
<img width="80" align="left" src="./resources/icons/glip.png" alt="Glip" title="Glip">
<img width="80" align="left" src="./resources/icons/mysms.png" alt="mysms" title="mysms">
<img width="80" align="left" src="./resources/icons/icq.png" alt="ICQ" title="ICQ">

<img width="80" align="left" src="./resources/icons/tweetdeck.png" alt="TweetDeck" title="TweetDeck">
<img width="80" align="left" src="./resources/icons/zinc.png" alt="Zinc" title="Zinc">
<img width="80" align="left" src="./resources/icons/freenode.png" alt="FreeNode" title="FreeNode">
<img width="80" align="left" src="./resources/icons/mightytext.png" alt="MightyText" title="MightyText">
<img width="80" align="left" src="./resources/icons/zohoemail.png" alt="Zoho Email" title="Zoho Email">
<img width="80" align="left" src="./resources/icons/zohochat.png" alt="Zoho Chat" title="Zoho Chat">
<img width="80" align="left" src="./resources/icons/roundcube.png" alt="Roundcube" title="Roundcube">
<img width="80" align="left" src="./resources/icons/horde.png" alt="Horde" title="Horde">
<img width="80" align="left" src="./resources/icons/squirrelmail.png" alt="SquirrelMail" title="SquirrelMail">
<img width="80" align="left" src="./resources/icons/zimbra.png" alt="Zimbra" title="Zimbra">

<img width="80" align="left" src="./resources/icons/hootsuite.png" alt="Hootsuite" title="Hootsuite">
<img width="80" align="left" src="./resources/icons/amium.png" alt="Amium" title="Amium">
<img width="80" align="left" src="./resources/icons/rainloop.png" alt="RainLoop" title="RainLoop">
<img width="80" align="left" src="./resources/icons/icloud.png" alt="iCloud Mail" title="iCloud Mail">
<img width="80" align="left" src="./resources/icons/irccloud.png" alt="IRC Cloud" title="IRC Cloud">
<img width="80" align="left" src="./resources/icons/kiwi.png" alt="Kiwi IRC" title="Kiwi IRC">
<img width="80" align="left" src="./resources/icons/smooch.png" alt="Smooch" title="Smooch">
<img width="80" align="left" src="./resources/icons/crisp.png" alt="Crisp" title="Crisp">
<img width="80" align="left" src="./resources/icons/flock.png" alt="Flock" title="Flock">
<img width="80" align="left" src="./resources/icons/openmailbox.png" alt="Openmailbox" title="Openmailbox">

<img width="80" align="left" src="./resources/icons/typetalk.png" alt="Typetalk" title="Typetalk">
<img width="80" align="left" src="./resources/icons/drift.png" alt="Drift" title="Drift">
<img width="80" align="left" src="./resources/icons/webexteams.png" alt="Cisco Webex Teams" title="Cisco Webex Teams">
<img width="80" align="left" src="./resources/icons/fleep.png" alt="Fleep" title="Fleep">
<img width="80" align="left" src="./resources/icons/socialcast.png" alt="Socialcast" title="Socialcast">
<img width="80" align="left" src="./resources/icons/element.png" alt="Element" title="Element">
<img width="80" align="left" src="./resources/icons/pushbullet.png" alt="Pushbullet" title="Pushbullet">
<img width="80" align="left" src="./resources/icons/movim.png" alt="Movim" title="Movim">

<img width="80" align="left" src="./resources/icons/kaiwa.png" alt="Kaiwa" title="Kaiwa">
<img width="80" align="left" src="./resources/icons/zyptonite.png" alt="Zyptonite" title="Zyptonite">
<img width="80" align="left" src="./resources/icons/linkedin.png" alt="LinkedIn" title="LinkedIn">
<img width="80" align="left" src="./resources/icons/lounge.png" alt="The Lounge" title="The Lounge">
<img width="80" align="left" src="./resources/icons/kezmo.png" alt="Kezmo" title="Kezmo">
<img width="80" align="left" src="./resources/icons/teams.png" alt="Teams" title="Teams">
<img width="80" align="left" src="./resources/icons/xing.png" alt="Xing" title="Xing">
<img width="80" align="left" src="./resources/icons/workplace.png" alt="Workplace" title="Workplace">
<img width="80" align="left" src="./resources/icons/fastmail.png" alt="FastMail" title="FastMail">
<img width="80" align="left" src="./resources/icons/hibox.png" alt="Hibox" title="Hibox">
<img width="80" align="left" src="./resources/icons/jandi.png" alt="Jandi" title="Jandi">
<img width="80" align="left" src="./resources/icons/threema.png" alt="Threema" title="Threema">
<img width="80" align="left" src="./resources/icons/messengerpages.png" alt="Messenger for Pages" title="Messenger for Pages">
<img width="80" align="left" src="./resources/icons/vk.png" alt="VK Messenger" title="VK Messenger">
<img width="80" align="left" src="./resources/icons/mastodon.png" alt="Mastodon" title="Mastodon">
<img width="80" align="left" src="./resources/icons/teamworkchat.png" alt="Teamwork Chat" title="Teamwork Chat">
<img width="80" align="left" src="./resources/icons/clocktweets.png" alt="ClockTweets" title="ClockTweets">
<img width="80" align="left" src="./resources/icons/intercom.png" alt="Intercom" title="Intercom">
<img width="80" align="left" src="./resources/icons/googlevoice.png" alt="Voice" title="Voice">
<img width="80" align="left" src="./resources/icons/sandstorm.png" alt="Sandstorm" title="Sandstorm">
<img width="80" align="left" src="./resources/icons/gadugadu.png" alt="Gadu-Gadu" title="Gadu-Gadu">
<img width="80" align="left" src="./resources/icons/mailru.png" alt="Mail.Ru" title="Mail.Ru">
<img width="80" align="left" src="./resources/icons/kune.png" alt="Kune" title="Kune">
<img width="80" align="left" src="./resources/icons/zulip.png" alt="Zulip" title="Zulip">
<img width="80" align="left" src="./resources/icons/stride.png" alt="Stride" title="Stride">
<img width="80" align="left" src="./resources/icons/hangoutschat.png" alt="Hangouts Chat" title="Hangouts Chat">
<img width="80" align="left" src="./resources/icons/messengerpages.png" alt="Messenger for Business" title="Messenger for Business">
<img width="80" align="left" src="./resources/icons/androidmessages.png" alt="Android Messages" title="Android Messages">

<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>

----------

## Features

- [ ] Multi-language.
- [ ] Sync your configuration between multiple computers.
- [x] Master Password.
- [x] Lock Hamsket if you will be away for a period of time.
- [x] Don't disturb mode.
- [x] Reorder applications in the tab bar.
- [x] Notification badge in the tab.
- [x] Minimize to tray.
- [x] Mute audio to specific service.
- [x] Separate tabs floating to the right.
- [x] Disable a service instead of remove it.
- [x] Start automatically on system startup.
- [x] Custom Javascript injection.
- [x] Custom CSS injection.
- [x] Keyboard Shortcuts.
- [x] Proxy.
- [x] Passive mouse/touch event listeners by default.
- [x] Lowered timer granularity to save CPU time by default.
- [x] No user tracking.
- [x] Fully open source, won't change
- [x] Highly responsive to issues, PRs, and help.
- [x] Offline backup and restore.

----------

## Privacy

No personal information will be saved or tracked.

Sessions will persist using the [partition:persist](https://electronjs.org/docs/api/webview-tag#partition) attribute for Webviews. So every time you open Hamsket, your sessions will keep alive until you remove the service.

~~Sync feature use [Auth0](https://auth0.com/) for Single Sign On & Token Based Authentication and to store the services that user is using (and the configuration for each service). You are always welcome to check the code! ;)~~

Auth0 is disabled pending name change and rewrite of the functionality to best preserve your security and functionality.

----------

## Donations

Keep in mind, I'm not pushing this. I'll do my best regardless.

| Type         |                    URL/Wallet                    |
| ------------ | :----------------------------------------------: |
| GoFundMe     |       <https://www.gofundme.com/Hamsket>       |

----------

## Compiling

To build your own copy, you need:

- An 8.0 version of the [Java SE Development Kit](http://www.oracle.com/technetwork/java/javase/downloads/index.html).
- [Ruby](https://www.ruby-lang.org/en/downloads/) 2.3 or newer.
- [Sencha CMD](https://www.sencha.com/products/extjs/cmd-download/) 6.7.0 or newer, and to install it with the Compass extension.
- [NodeJS](https://nodejs.org/en/download/) 8.5.0 (10.0+ preferred) or newer with npm.

These **need** to be added to your PATH.

```shell
git clone https://github.com/TheGoddessInari/hamsket.git
cd hamsket
npm install
npm run repack:win64
```

You can substitute win64 for linux32, linux64, win32, or osx as desired. This will create an unpacked directory in '**dist**' for testing.

```shell
npm run setup
```

This step instead of **repack** will create an installer appropriate to your platform in '**dist**'.
You can place unpacked files over where the installers normally place their files for development/testing purposes.

**NOTE:** 32-bit builds are **deprecated** by electron-builder and are likely to be removed at some point in the future.

----------

## [Contributing](./CONTRIBUTING.md)

Want to report a bug, request a feature, contribute to or translate Hamsket? We need all the help we can get! Fork and work!

----------

## Quickstart

```shell
git clone https://github.com/TheGoddessInari/hamsket.git
cd hamsket
npm install
npm start
```

See [Contributing.md](./CONTRIBUTING.md) for more detailed information about getting set up.

----------

## Disclosure

Hamsket is not affiliated with any of the messaging apps offered.

----------

## License

[GNU GPL v3](./LICENSE)

----------
